import {
  defineComponent,
  h,
  reactive,
  watch,
  toRefs,
  onMounted,
  onUnmounted,
} from "@vue/runtime-core";

export default defineComponent({
  props: ["x", "y"],
  setup(props, ctx) {
    console.log("----------> Plane.js props start <----------");
    console.log(props);

    const handleAttack = (e) => {
      if (e.code === "Space") {
        // console.log('attack')
        // console.log(e.code)
        ctx.emit("attack", {
          x: props.x,
          y: props.y,
        });
      }
    };
    onMounted(() => {
      console.log("----------> Plane.js onMounted <----------")
      // window.addEventListener("keydown", handleAttack);
    });
    onUnmounted(() => {
      console.log("----------> Plane.js onUnmounted <----------")
      // window.removeEventListener("keydown", handleAttack);
    });

    const point = reactive({
      x: props.x,
      y: props.y,
    });
    watch(props, (value) => {
      point.x = value.x;
      point.y = value.y;
    });

    console.log("---props---");
    console.log(props.x);
    // toRefs
    const { x, y } = toRefs(props);

    console.log(x, y);

    console.log("----------> Plane.js props end <----------");
    return {
      x,
      y,
    };
  },
  render(ctx) {
    return h("Container", { x: ctx.x, y: ctx.y }, [
      h("Sprite", { texture: "../../assets/plane.png" }),
    ]);
  },
});
