import { createRenderer } from "@vue/runtime-core";

// 创建渲染器
const renderer = createRenderer({
  // 实现渲染接口
  createElement(type) {
    console.log("==========> runtime-canvas create element start <==========")
    let element = undefined;
    // 基于 type 去创建视图
    switch (type) {
      case "Container":
        element = TWindow.create(null, 0, 0, 0, 0);
        var label = TLabel.create(element, 0, 0, 0, 0);
      
        label.useStyle(123);
        label.setText("hello awtk!");
        label.setSelfLayoutParams("center", "middle", "50%", "30");
      
        element.layout();
        console.log(type);
        break;
      case "Sprite":
        element = TColor.create(1, 2, 3, 4);
        console.log(type)
        break;
    }
    console.log("==========> runtime-canvas create element end <==========")
    return element;
  },
  insert(el, parent) {
    console.log("==========> insert start <==========");
    console.log(el);
    console.log(JSON.stringify(el))
    console.log(parent);
    el.parent = parent;
    console.log(JSON.stringify(parent))
    if (parent && parent.hasOwnProperty("children")) parent.children.push(el);
    console.log("==========> insert end <==========");
  },
  patchProp(el, key, prevValue, nextValue) {
    console.log("==========> patch prop start <==========");
    console.log(el)
    console.log(key)
    console.log(prevValue)
    console.log(nextValue)
    switch (key) {
      case "texture":
        // el.texture = Texture.from(nextValue);
        break;
      case "onClick":
        // 给pixi元素注册点击事件
        // el.on("pointertap", nextValue);
        break;
      default:
        if (el) el[key] = nextValue;
    }
    console.log("==========> patch prop end <==========");
  },
  setElementText(node, text) {
    console.log("==========> set element text start <==========");
    console.log(node)
    console.log(text)
    // const canvasText = new Text(text);
    // node.addChild(canvasText);
    console.log("==========> set element text end <==========");
  },
  createText(text) {
    console.log("==========> create text start <==========");
    console.log(text)
    console.log("==========> create text end <==========");
    // return new Text(text);
    return text
  },
  // 处理注释
  createComment() {},
  // 获取父节点
  parentNode(node) {
    console.log("==========> parent node start <==========");
    console.log(node);
    console.log("==========> parent node end <==========");
  },
  // 获取兄弟节点
  nextSibling() {},
  // 删除节点时调用
  remove(el) {
    console.log("==========> remove start <==========");
    const parent = el.parent;
    if (parent) {
      parent.removeChild(el);
    }
    console.log("==========> remove end <==========");
  },
});
// console.log(renderer)

export function createApp(rootComponent) {
  // 调用 renderer
  return renderer.createApp(rootComponent);
}
